;##-----------------------------LICENSE NOTICE------------------------------------
;##  This file is part of Two Finger Death Now: An Amstrad CPC Game 
;##  Copyright (C) 2018 Adrián Gordo Prieto / @spherp08
;##
;##  This program is free software: you can redistribute it and/or modify
;##  it under the terms of the GNU Lesser General Public License as published by
;##  the Free Software Foundation, either version 3 of the License, or
;##  (at your option) any later version.
;##
;##  This program is distributed in the hope that it will be useful,
;##  but WITHOUT ANY WARRANTY; without even the implied warranty of
;##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;##  GNU Lesser General Public License for more details.
;##
;##  You should have received a copy of the GNU Lesser General Public License
;##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;##------------------------------------------------------------------------------

.area _CODE


.globl _sprite_enemy1_18x16
.globl _sprite_enemy2_18x16

restar_vida: .db #0

;; Para utilizar el teclado
.include "keyboard.s"
.include "cpctelera.h.s"
.include "hero.h.s"
.include "enemy.h.s"
.include "hud.h.s"
.include "macros.h.s"

 e_x = 0
 e_y = 1
 e_vx = 2
 e_vy = 3
 e_w = 4
 e_h = 5
 e_sp_l = 6
 e_sp_h = 7
 e_up_l = 8
 e_up_h = 9

DefineEntity enemy_data,  0x46, 0x66, 0xFF, 0x00, 0x09, 0x10, _sprite_enemy1_18x16, ent_move
DefineEntity enemy_data2, 0x46, 0x66, 0xFF, 0x00, 0x09, 0x10, _sprite_enemy1_18x16, ent_move
DefineEntity enemy_data3, 0x46, 0x66, 0xFF, 0x00, 0x09, 0x10, _sprite_enemy1_18x16, ent_move
DefineEntity enemy_data4, 0x00, 0x66, 0x01, 0x00, 0x09, 0x10, _sprite_enemy2_18x16, ent_move2
DefineEntity enemy_data5, 0x00, 0x66, 0x01, 0x00, 0x09, 0x10, _sprite_enemy2_18x16, ent_move2
DefineEntity enemy_data6, 0x00, 0x66, 0x01, 0x00, 0x09, 0x10, _sprite_enemy2_18x16, ent_move2
 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJAR UNA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_draw:
  ld    de, #0xC000       ;;Comienzo memoria de video
  ld     c, e_x(ix)         ;; C = Entity Y
  ld     b, e_y(ix)         ;; B = Entity X
  call cpct_getScreenPtr_asm
 
  ex    de, hl   ;; DE = Puntero a memoria
  ld l, e_sp_l(ix)
  ld h, e_sp_h(ix)
  ld  b, e_h(ix)   ;; alto
  ld  c, e_w(ix)   ;; Ancho
 
  call cpct_drawSprite_asm
 
  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; BORRA UNA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, AF'', BC, DE, HL
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_clear:

  ret
  ent_clear2:
 
  ret

ent_reset::

    ld    e_x(ix), #0

ret


ent_reset2::

    ld    e_x(ix), #80-9

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZAR UNA ENTIDAD
;; REGISTROS DESTRUIDOS:
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_update:
  ld     h, e_up_h(ix)
  ld     l, e_up_l(ix)
  jp    (hl)

ent_moveRight:
  ld    a, e_x(ix)
    add   e_vx(ix)
    ld    e_x(ix), a
    cp #0x1C
    jr nz, not_restart_l
    
    ld    e_x(ix), #0
	call clear_draw2

not_restart_l:
    
ret 

ent_moveLeft:
  ld    a, e_x(ix)
    add   e_vx(ix)
    ld    e_x(ix), a
    cp #0x2B
    jp nz, not_restart_r
    
    ld    e_x(ix), #80-10
    call clear_draw
    
not_restart_r:

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVER UNA ENTIDAD
;; REGISTROS DESTRUIDOS:
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move:
  call ent_moveLeft
 
  ret

  ent_move2:
  call ent_moveRight
 
  ret


enemy_CheckCollisionLeft::
;; enemy_x+enemy_w-hero_x<=0
ld b, #05
ld a, e_x(ix)
ld c, a
ld a, e_w(ix)
add c
sub (hl)
add b
jp m, no_collision_l

ld (restar_vida), a

;; Collision
call cpct_scanKeyboard_asm
ld hl, #Key_A
call cpct_isKeyPressed_asm
cp #0
jr z, a_not_pressed

dec hl
ld a, #0
ld e_x(ix), a
call increase_score2
call clear_draw2

a_not_pressed:
ld b, #05
ld a, (restar_vida)
sub b
jp m, no_collision_l
call decrease_health
call clear_draw2

ret

no_collision_l:
ld a, #00
dec hl

ret

enemy_CheckCollisionRight::
;; hero_x+hero_w-enemy_x<=0
ld b, #07
ld a, (hl)
inc hl
inc hl
add (hl)
add b
ld c, a
ld a, e_x(ix)
ld b, a
ld a, c
sub b
jp m, no_collision_r

ld (restar_vida), a

;; Collision
call cpct_scanKeyboard_asm
ld hl, #Key_D
call cpct_isKeyPressed_asm
cp #0
jr z, d_not_pressed

dec hl
ld a, #80-9
ld e_x(ix), a
call clear_draw
call increase_score2

d_not_pressed:
ld b, #05
ld a, (restar_vida)
sub b
jp m, no_collision_r
call decrease_health
call clear_draw

ret

no_collision_r:
ld a, #00
dec hl

ret

get_x::
ld a, e_x(ix)

ret