;##-----------------------------LICENSE NOTICE------------------------------------
;##  This file is part of Two Finger Death Now: An Amstrad CPC Game 
;##  Copyright (C) 2018 Adrián Gordo Prieto / @spherp08
;##
;##  This program is free software: you can redistribute it and/or modify
;##  it under the terms of the GNU Lesser General Public License as published by
;##  the Free Software Foundation, either version 3 of the License, or
;##  (at your option) any later version.
;##
;##  This program is distributed in the hope that it will be useful,
;##  but WITHOUT ANY WARRANTY; without even the implied warranty of
;##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;##  GNU Lesser General Public License for more details.
;##
;##  You should have received a copy of the GNU Lesser General Public License
;##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;##------------------------------------------------------------------------------

.area _CODE

;; Variables de posicion del heroe
hero_x: .db #0x24
hero_y: .db #0x66
hero_w: .db #0x06
hero_h: .db #0x12
sprite_flip: .db #0

.globl _sprite_hero_16x16

;; Para utilizar el teclado
.include "keyboard.s"
.include "cpctelera.h.s"
.include "macros.h.s"
.include "hero.h.s"


hero_update::
call checkUserInput
ret

hero_draw::      ;; Dibujar hero
ld a, #0xCC
call drawHero

ret

hero_clear::   ;; Repintar fondo
ld a, #0x00
call drawHero

ret

hero_GetPointerHL::
ld hl, #hero_x

ret


moveHeroRight:

ld a, (sprite_flip)
    cp #0
    jr z, do_not_move_r
    
    ld a, #0
    ld (sprite_flip), a
  ld hl, #_sprite_hero_16x16
  ld  b, #0x10   ;; alto
  ld  c, #0x08   ;; Ancho
    call cpct_hflipSpriteM0_asm
    
do_not_move_r:

ret 

moveHeroLeft:

    
ld a, (sprite_flip)
    cp #1
    jr z, do_not_move_l
    
    ld a, #1
    ld (sprite_flip), a

  ld hl, #_sprite_hero_16x16
  ld  b, #0x10   ;; alto
  ld  c, #0x08   ;; Ancho
    call cpct_hflipSpriteM0_asm

do_not_move_l:

ret


;; Para ver las teclas pulsadas
checkUserInput:
call cpct_scanKeyboard_asm
ld hl, #Key_D
call cpct_isKeyPressed_asm
cp #0
jr z, d_not_pressed

call moveHeroRight

d_not_pressed:


ld hl, #Key_A
call cpct_isKeyPressed_asm
cp #0
jr z, a_not_pressed

call moveHeroLeft
    
a_not_pressed:


ret


;; Dibujar al heroe
drawHero:

   ld   de, #0xC000    ;; DE = Pointer to start of the screen
   ld a, (hero_x)
   ld c, a
   ld a, (hero_y)
   ld b, a
   call cpct_getScreenPtr_asm
 
  ex    de, hl   ;; DE = Puntero a memoria
  ld hl, #_sprite_hero_16x16
  ld  b, #0x10   ;; alto
  ld  c, #0x08   ;; Ancho
  call cpct_drawSprite_asm

ret