;##-----------------------------LICENSE NOTICE------------------------------------
;##  This file is part of Two Finger Death Now: An Amstrad CPC Game 
;##  Copyright (C) 2018 Adrián Gordo Prieto / @spherp08
;##
;##  This program is free software: you can redistribute it and/or modify
;##  it under the terms of the GNU Lesser General Public License as published by
;##  the Free Software Foundation, either version 3 of the License, or
;##  (at your option) any later version.
;##
;##  This program is distributed in the hope that it will be useful,
;##  but WITHOUT ANY WARRANTY; without even the implied warranty of
;##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;##  GNU Lesser General Public License for more details.
;##
;##  You should have received a copy of the GNU Lesser General Public License
;##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;##------------------------------------------------------------------------------

.area _CODE

.globl _hud_heart
.globl _hud_clear


score1: .db #0x00
score2: .db #0x00
score3: .db #0x00
score4: .db #0x00
hp: .db #5
var: .db #0
pos_var: .dw #0

;; ------------------------
;; Equivalencias del score que nada tienen que ver con el enemy
;; ------------------------
.equ score_digito_menos_significativo, 2
.equ score_segundo_digito_menos_significativo, 1
.equ score_tercer_digito_menos_significativo, 0

;; Para utilizar el teclado
.include "keyboard.s"
.include "cpctelera.h.s"
.include "hud.h.s"
.include "levels.h.s"
.include "macros.h.s"

str_score: .asciz "Score";

str_youDied: .asciz "You Died";
str_retry: .asciz "Press R to Retry";

str_youMaster: .asciz "You are a Master";
str_boast: .asciz "Boast About It";
str_retry2: .asciz "Or Press R to Retry";

str_level1: .asciz "Level 1";
str_level2: .asciz "Level 2";
str_level3: .asciz "Level 3";
str_level4: .asciz "Level 4";
str_level5: .asciz "Level 5";

DefineHealth health, 0x05, 0xB4, 0x08, 0x0E, 0x05, _hud_heart

 h_x = 0
 h_y = 1
 h_w = 2
 h_h = 3
 h_value = 4
 h_sp_l = 5
 h_sp_h = 6


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJAR LA VIDA
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
heart_draw:
 ld    de, #0xC000       ;;Comienzo memoria de video
  ld     c, h_x(ix)         ;; C = Entity Y
  ld     b, h_y(ix)         ;; B = Entity X
  call cpct_getScreenPtr_asm
 
  ex    de, hl   ;; DE = Puntero a memoria
  ld l, h_sp_l(ix)
  ld h, h_sp_h(ix)
  ld  b, h_h(ix)   ;; alto
  ld  c, h_w(ix)   ;; Ancho
 
  call cpct_drawSprite_asm

ret

health_draw:
ld a, (hp)
ld (var), a
ld   bc, #0xB710
ld (pos_var), bc
call draw_char

ret

decrease_health:
ld b, #01
    ld a, (hp)
    sub b
    ld (hp), a
    call z, game_over
    call health_draw
ret

reset_health::
    ld a, (hp)
    ld a, #5
    ld (hp), a 
    call health_draw
ret

level1_draw::
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x001A
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #15
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_level1
  call cpct_drawStringM0_asm

   ret

   level2_draw::
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x001A
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #15
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_level2
  call cpct_drawStringM0_asm

   ret

   level3_draw::
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x001A
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #15
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_level3
  call cpct_drawStringM0_asm

   ret

   level4_draw::
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x001A
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #15
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_level4
  call cpct_drawStringM0_asm

   ret

   level5_draw::
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x001A
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #15
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_level5
  call cpct_drawStringM0_asm

   ret

sc_draw::
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0xB724
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #12
      ld l, #0
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_score
  call cpct_drawStringM0_asm

   ret

score1_value_draw:
ld a, (score1)
ld (var), a
ld   bc, #0xAF9B 
ld (pos_var), bc
call draw_char

ret

score2_value_draw::

ld a, (score2)
ld (var), a
ld   bc, #0xAF96 
ld (pos_var), bc
call draw_char

ret

score3_value_draw::
ld a, (score3)
cp #2
call z, incr2

ld a, (score3)
ld (var), a
ld   bc, #0xAF91 
ld (pos_var), bc
call draw_char
ret

incr2:
call get_level
cp #1
call z, increase_level
ld a, (score3)
ld (var), a
ld   bc, #0xAF91 
ld (pos_var), bc
call draw_char
call level2_draw

ret

score4_value_draw::
ld a, (score4)
cp #2
call z, incr3

ld a, (score4)
cp #4
call z, incr4

ld a, (score4)
cp #7
call z, incr5

ld a, (score4)
ld (var), a
ld   bc, #0xAF8C 
ld (pos_var), bc
call draw_char
ret

incr3:
call get_level
cp #2
call z, increase_level

ld a, (score4)
ld (var), a
ld   bc, #0xAF8C 
ld (pos_var), bc
call draw_char
call level3_draw

ret

incr4:
call get_level
cp #3
call z, increase_level

ld a, (score4)
ld (var), a
ld   bc, #0xAF8C 
ld (pos_var), bc
call draw_char
call level4_draw

ret

incr5:
call get_level
cp #4
call z, increase_level

ld a, (score4)
ld (var), a
ld   bc, #0xAF8C 
ld (pos_var), bc
call draw_char
call level5_draw

ret

increase_score1:
ld b, #09
    ld a, (score1)
    add b
    ld (score1), a
call score1_value_draw
ret

increase_score2:
    ld a, (score2)
   cp #8
    jr nz, no2_8
    ld a, (score4)  
    cp #9
    jr z, score_fin
   call reset_score2
   call increase_score3

   ret

   score_fin:
    ld a, (score3)  
    cp #9
    jr z, score_fin2
    call reset_score2
    call increase_score3

    ret

    score_fin2:
ld b, #01 
ld a, (score2)
add b
ld (score2), a
call score2_value_draw
call you_win
call increase_score1

ret

   no2_8:
ld b, #02
    add b
    ld (score2), a
call score2_value_draw
ret

increase_score3:
ld b, #01
    ld a, (score3)  
    cp #9
    jr nz, no3_9
   call reset_score3
   call increase_score4

   ret

   no3_9:
    add b
    ld (score3), a
call score3_value_draw
ret

increase_score4:
ld b, #01
    ld a, (score4)
    add b
    ld (score4), a
call score4_value_draw
ret

reset_score1::
    ld a, (score1)
    ld a, #0
    ld (score1), a 
call score1_value_draw
ret

reset_score2::
    ld a, (score2)
    ld a, #0
    ld (score2), a 
call score2_value_draw
ret

reset_score3::
    ld a, (score3)
    ld a, #0
    ld (score3), a 
call score3_value_draw
ret

reset_score4::
    ld a, (score4)
    ld a, #0
    ld (score4), a 
call score4_value_draw
ret

you_win:
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x4608
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #12
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_youMaster
  call cpct_drawStringM0_asm

  ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x500C
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #12
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_boast
  call cpct_drawStringM0_asm

  ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x5A02
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #12
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_retry2
  call cpct_drawStringM0_asm
call reset_stop_enemies

ret

game_over:
ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x5018
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #6
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_youDied
  call cpct_drawStringM0_asm

  ld   de, #0xC000    ;; DE = Pointer to start of the screen
ld   bc, #0x5A08
   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL

   push  hl        
      ld h, #0
      ld l, #6
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
pop hl
   ld iy, #str_retry
  call cpct_drawStringM0_asm

call reset_stop_enemies

ret

draw_char:
ld   de, #0xC000    ;; DE = Pointer to start of the screen
   ld   bc, (pos_var)    ;; B  = y coordinate (0x18 = 24), C = x coordinate (0x10 = 16)

   call cpct_getScreenPtr_asm ;; Calculate video memory location and return it in HL
   push  hl        
      ld h, #12
      ld l, #0
   ;; Set colours to be used by DrawChar/DrawStringM0 functions
   call  cpct_setDrawCharM0_asm  ;; Set colours before using DrawCharM0
   ld   a, (var)
   cp #9
    jr nz, no_9
   ld e, #57
   jp numbers

   no_9:
   ld   a, (var)
   cp #8
    jr nz, no_8
   ld e, #56
   jp numbers

   no_8:
   ld   a, (var)
   cp #7
    jr nz, no_7
   ld e, #55
   jp numbers

   no_7:
   ld   a, (var)
   cp #6
    jr nz, no_6
   ld e, #54
   jp numbers

   no_6:
   ld   a, (var)
   cp #5
    jr nz, no_5
   ld e, #53
   jp numbers

   no_5:
   ld   a, (var)
   cp #4
    jr nz, no_4
   ld e, #52
   jp numbers

   no_4:
   ld   a, (var)
   cp #3
    jr nz, no_3
   ld e, #51
   jp numbers

   no_3:
   ld   a, (var)
   cp #2
    jr nz, no_2
   ld e, #50
   jp numbers

   no_2:
   ld   a, (var)
   cp #1
    jr nz, no_1
   ld e, #49
   jp numbers

   no_1:
   ld e, #48
   jp numbers

    numbers:

   pop   hl         
   call cpct_drawCharM0_asm  ;; Draw the char
ret

clear_draw::
   ld   de, #0xC000    ;; DE = Pointer to start of the screen
   ld   bc, #0x642C    ;; B  = y coordinate (0x18 = 24), C = x coordinate (0x10 = 16)
  call cpct_getScreenPtr_asm
 
  ex    de, hl   ;; DE = Puntero a memoria
  ld hl, #_hud_clear
  ld  b, #0x12   ;; alto
  ld  c, #0x0F   ;; Ancho
  call cpct_drawSprite_asm
ret

clear_draw2::
   ld   de, #0xC000    ;; DE = Pointer to start of the screen
   ld   bc, #0x6415    ;; B  = y coordinate (0x18 = 24), C = x coordinate (0x10 = 16)
  call cpct_getScreenPtr_asm
 
  ex    de, hl   ;; DE = Puntero a memoria
  ld hl, #_hud_clear
  ld  b, #0x12   ;; alto
  ld  c, #0x0F   ;; Ancho
  call cpct_drawSprite_asm
ret

