;##-----------------------------LICENSE NOTICE------------------------------------
;##  This file is part of Two Finger Death Now: An Amstrad CPC Game 
;##  Copyright (C) 2018 Adrián Gordo Prieto / @spherp08
;##
;##  This program is free software: you can redistribute it and/or modify
;##  it under the terms of the GNU Lesser General Public License as published by
;##  the Free Software Foundation, either version 3 of the License, or
;##  (at your option) any later version.
;##
;##  This program is distributed in the hope that it will be useful,
;##  but WITHOUT ANY WARRANTY; without even the implied warranty of
;##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;##  GNU Lesser General Public License for more details.
;##
;##  You should have received a copy of the GNU Lesser General Public License
;##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;##------------------------------------------------------------------------------

.area _CODE


;; Para utilizar el teclado
.include "keyboard.s"
.include "cpctelera.h.s"
.include "hud.h.s"
.include "macros.h.s"
.include "enemy.h.s"
.include "hero.h.s"

enemy_reset: .db #00

enemy_timer_create: .db #30    
enemy_timer_create2: .db #40   
enemy_timer_create3: .db #20     
enemy_timer_create4: .db #40    
enemy_timer_create5: .db #20  
enemy_timer_create6: .db #0  

enemy_move:  .db #25
enemy_timer_move: .db #25

level_actual: .db #01

reset_stop_enemies::
ld b, #01
ld a, (enemy_reset)
add b
ld (enemy_reset), a

ret

stop_enemies::
ld a, (enemy_reset)
cp #0
jr z, res
ld b, #01
ld a, (enemy_reset)
sub b
ld (enemy_reset), a

res:
ld    ix, #enemy_data
  call ent_reset2

ld    ix, #enemy_data2
  call ent_reset2

ld    ix, #enemy_data3
  call ent_reset2

ld    ix, #enemy_data4
  call ent_reset

ld    ix, #enemy_data5
  call ent_reset

ld    ix, #enemy_data6
  call ent_reset

ld a, #01
ld (level_actual), a

ret

get_level::
ld a, (level_actual)

ret

increase_level::
ld b, #01
ld a, (level_actual)
add b
ld (level_actual), a
cp #01
    jr nz, no_1

ld a, #25
ld (enemy_move), a

ld a, #40
ld (enemy_timer_create), a
jp inc

no_1:
ld a, (level_actual)
cp #02
    jr nz, no_2

ld a, #20
ld (enemy_move), a

ld a, #0
ld (enemy_timer_create), a
jp inc

no_2:
ld a, (level_actual)
cp #03
    jr nz, no_3

ld a, #18
ld (enemy_move), a

ld a, #0
ld (enemy_timer_create), a

ld a, #40
ld (enemy_timer_create2), a
ld a, #20
ld (enemy_timer_create3), a
jp inc

  no_3:
ld a, (level_actual)
cp #04
    jr nz, no_4

ld a, #18
ld (enemy_move), a

ld a, #0
ld (enemy_timer_create), a
ld a, #40
ld (enemy_timer_create2), a
ld a, #20
ld (enemy_timer_create3), a
jp inc

  no_4:
ld a, (level_actual)
ld a, #15
ld (enemy_move), a

ld a, #0
ld (enemy_timer_create), a
ld a, #20
ld (enemy_timer_create2), a
ld a, #20
ld (enemy_timer_create3), a
ld a, #40
ld (enemy_timer_create4), a
jp inc

inc:

ret

selec_level::
ld a, (enemy_reset)
cp #1
jr z, lvl

ld a, (level_actual)
cp #01
    jr nz, no1
  call level1
jp lvl

no1:
ld a, (level_actual)
cp #02
    jr nz, no2
  call level2
jp lvl

no2:
ld a, (level_actual)
cp #03
    jr nz, no3
  call level3
jp lvl

  no3:
ld a, (level_actual)
cp #04
    jr nz, no4
  call level4
jp lvl

  no4:
ld a, (level_actual)
  call level5
jp lvl

lvl:

ret

level1:

ld b, #01
 ld a, (enemy_timer_move) 
 sub b 
    ld (enemy_timer_move), a
    jr nz, salir 

ld a, (enemy_move)
ld (enemy_timer_move), a
call enemy1
call enemy4

salir:
    

ret


level2:
ld b, #01
 ld a, (enemy_timer_move) 
 sub b 
    ld (enemy_timer_move), a
    jr nz, salir2 

ld a, (enemy_move)
ld (enemy_timer_move), a
call enemy1
call enemy4
call enemy5

salir2:

ret

level3:
ld b, #01
 ld a, (enemy_timer_move) 
 sub b 
    ld (enemy_timer_move), a
    jr nz, salir3 

ld a, (enemy_move)
ld (enemy_timer_move), a
call enemy1
call enemy2
call enemy4
call enemy5

salir3:

ret


level4:
ld b, #01
 ld a, (enemy_timer_move) 
 sub b 
    ld (enemy_timer_move), a
    jr nz, salir4 

ld a, (enemy_move)
ld (enemy_timer_move), a
call enemy1
call enemy2
call enemy3
call enemy4
call enemy5

salir4:

ret

level5:
ld b, #01
 ld a, (enemy_timer_move) 
 sub b 
    ld (enemy_timer_move), a
    jr nz, salir5 

ld a, (enemy_move)
ld (enemy_timer_move), a
call enemy1
call enemy2
call enemy3
call enemy4
call enemy5
call enemy6

salir5:

ret

enemy1:
ld a, (enemy_timer_create6) 
    cp #0                 
    jr nz, e11
ld    ix, #enemy_data
  call ent_clear
  call ent_update
call hero_GetPointerHL
call enemy_CheckCollisionRight
call get_x
cp #80-10            
    jr z, e1
  call ent_draw
ret
e1:
 ld a, #5 
    ld (enemy_timer_create6), a
    ret
    e11:
    ld b, #01
    ld a, (enemy_timer_create6) 
    sub b 
    ld (enemy_timer_create6), a
ret

enemy2:
 ld a, (enemy_timer_create3) 
    cp #0                 
    jr nz, e22

ld    ix, #enemy_data2
  call ent_clear
  call ent_update
call hero_GetPointerHL
call enemy_CheckCollisionRight
call get_x
cp #80-10            
    jr z, e2
  call ent_draw
ret
e2:
 ld a, #15 
    ld (enemy_timer_create3), a
    ret
  call ent_draw

ret
e22:
ld b, #01
    ld a, (enemy_timer_create3) 
    sub b 
    ld (enemy_timer_create3), a
ret

enemy3:

 ld a, (enemy_timer_create4) 
    cp #0                 
    jr nz, e33

ld    ix, #enemy_data3
  call ent_clear
  call ent_update
call hero_GetPointerHL
call enemy_CheckCollisionRight
call get_x
cp #80-10            
    jr z, e3
  call ent_draw
ret
e3:
 ld a, #25 
    ld (enemy_timer_create4), a
    ret
  call ent_draw
ret
e33:

ld b, #01
    ld a, (enemy_timer_create4) 
    sub b 
    ld (enemy_timer_create4), a
ret

enemy4:

 ld a, (enemy_timer_create) 
    cp #0                 
    jr nz, e44

ld    ix, #enemy_data4
  call ent_clear2
  call ent_update
call hero_GetPointerHL
call enemy_CheckCollisionLeft
call get_x
cp #0            
    jr z, e4
  call ent_draw
ret
e4:
 ld a, #0 
    ld (enemy_timer_create), a
    ret
  call ent_draw
ret

e44:
ld b, #01
    ld a, (enemy_timer_create) 
    sub b 
    ld (enemy_timer_create), a

ret

enemy5:

 ld a, (enemy_timer_create2) 
    cp #0                 
    jr nz, e55

ld    ix, #enemy_data5
  call ent_clear2
  call ent_update
call hero_GetPointerHL
call enemy_CheckCollisionLeft
call get_x
cp #0            
    jr z, e5
  call ent_draw
ret
e5:
 ld a, #15 
    ld (enemy_timer_create2), a
    ret
  call ent_draw
ret

e55:
ld b, #01
    ld a, (enemy_timer_create2) 
    sub b 
    ld (enemy_timer_create2), a

ret

enemy6:

 ld a, (enemy_timer_create5) 
    cp #0                 
    jr nz, e66

ld    ix, #enemy_data6
  call ent_clear2
  call ent_update
call hero_GetPointerHL
call enemy_CheckCollisionLeft
call get_x
cp #0            
    jr z, e6
  call ent_draw
ret
e6:
 ld a, #25 
    ld (enemy_timer_create5), a
    ret
  call ent_draw
ret

e66:
ld b, #01
    ld a, (enemy_timer_create5) 
    sub b 
    ld (enemy_timer_create5), a
ret

