;##-----------------------------LICENSE NOTICE------------------------------------
;##  This file is part of Two Finger Death Now: An Amstrad CPC Game 
;##  Copyright (C) 2018 Adrián Gordo Prieto / @spherp08
;##
;##  This program is free software: you can redistribute it and/or modify
;##  it under the terms of the GNU Lesser General Public License as published by
;##  the Free Software Foundation, either version 3 of the License, or
;##  (at your option) any later version.
;##
;##  This program is distributed in the hope that it will be useful,
;##  but WITHOUT ANY WARRANTY; without even the implied warranty of
;##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;##  GNU Lesser General Public License for more details.
;##
;##  You should have received a copy of the GNU Lesser General Public License
;##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;##------------------------------------------------------------------------------

;###########################################################################
;#### FICHERO: macros.h.s
;###########################################################################

.macro DefineEntity _name, x, y, vx, vy, w, h, spr, upd
_name:
   .db   x, y     ;; X, Y
   .db   vx, vy     ;; VX, VY
   .db   w, h     ;; W, H
   .dw   spr           ;; Color
   .dw   upd           ;; Posición update
.endm
 .macro DefineEntityDefault _name, _suf
   DefineEntity _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0, 0XFFFF
.endm

.macro DefineNEntities _name, _n
_c = 0
.rept _n
   DefineEntityDefault _name, \_c
   _c = _c + 1
   .endm
.endm


.macro DefineMenu name, x, y, w, h, spr
	name'_data::
		name'_x: 	  	.db x
		name'_y:	    .db y  
		name'_w:	    .db w
		name'_h:	    .db h
		name'_sprite:  	.dw spr
.endm

.macro DefineHero name, x, y, w, h, spr
name'_data:
name'_x: .db x
name'_y: .db y
name'_w: .db w
name'_h: .db h
name'_sprite: .dw spr
.endm


.macro DefineHealth name, x, y, w, h, value, spr
	name'_data::
		name'_x: 	  	.db x
		name'_y:	    .db y  
		name'_w:	    .db w
		name'_h:	    .db h
		name'_v:	    .db value
		name'_sprite:  	.dw spr
.endm

.macro DefineScore name, x, y, w, h, c1, c2, c3, c4, value, spr
	name'_data::
		name'_x: 	  	.db x
		name'_y:	    .db y  
		name'_w:	    .db w
		name'_h:	    .db h
		name'_c1: 	  	.db c1
		name'_c2:	    .db c2  
		name'_c3:	    .db c3
		name'_c4:	    .db c4
		name'_v:	    .db value
		name'_sprite:  	.dw spr
.endm
