;##-----------------------------LICENSE NOTICE------------------------------------
;##  This file is part of Two Finger Death Now: An Amstrad CPC Game 
;##  Copyright (C) 2018 Adrián Gordo Prieto / @spherp08
;##
;##  This program is free software: you can redistribute it and/or modify
;##  it under the terms of the GNU Lesser General Public License as published by
;##  the Free Software Foundation, either version 3 of the License, or
;##  (at your option) any later version.
;##
;##  This program is distributed in the hope that it will be useful,
;##  but WITHOUT ANY WARRANTY; without even the implied warranty of
;##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;##  GNU Lesser General Public License for more details.
;##
;##  You should have received a copy of the GNU Lesser General Public License
;##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;##------------------------------------------------------------------------------

.area _DATA
.area _CODE

.include "hero.h.s"
.include "menu.h.s"
.include "map.h.s"
.include "hud.h.s"
.include "levels.h.s"
.include "keyboard.s"
.include "cpctelera.h.s"

.globl _sprite_palette
.globl _g_tileset
.globl _song_ingame


keyboard_timer: .db #0x06 
var_t: .db #6
var_cf: .db #0x10

isr:

ex af, af'
push af
exx
push bc
push de
push hl
push iy

ld a, (var_t)
dec a
ld (var_t), a
jr nz, return

call z, cpct_akp_musicPlay_asm
ld a, #6
ld (var_t), a

return:
pop iy
pop hl
pop de
pop bc
pop af
exx
ex af, af'

ret

;; Funcion principal
_main::   
call cpct_disableFirmware_asm

ld c, #0
call cpct_setVideoMode_asm

ld hl, #_sprite_palette
ld de, #16
call cpct_setPalette_asm

;; init music
ld de, #_song_ingame
call cpct_akp_musicInit_asm

;; Set isr
ld hl, #isr
call cpct_setInterruptHandler_asm

ld hl, #_g_tileset
call cpct_etm_setTileset2x4_asm


main_loop:

call clear_screen

call menu_draw1
call menu_draw2
call menu_draw3
call menu_draw4


loop:
        call cpct_scanKeyboard_asm
		ld hl, #Key_Space
		call cpct_isKeyPressed_asm	;;Check if Key_Space is presed
		cp #0						;;Check A == 0
		jr z, loop					;;Jump if A==0 

	
	call clear_screen


reset:
	call map_draw 

	ld    ix, #health_data
 	call heart_draw
    call reset_health
    
  	call sc_draw
    call reset_score1
    call reset_score2
    call reset_score3
    call reset_score4

	call level1_draw

	call stop_enemies
	

	game:

call hero_clear
call hero_update
call hero_draw

call selec_level

	
		call cpct_scanKeyboard_asm
		ld hl, #Key_R
		call cpct_isKeyPressed_asm	;;Check if Key_R is presed
		cp #0						;;Check A == 0
		jr nz, reset				;;Jump if A!=0 

		call cpct_scanKeyboard_asm
		ld hl, #Key_Esc
		call cpct_isKeyPressed_asm	;;Check if Key_Esc is presed
		cp #0						;;Check A == 0
		jr z, game					;;Jump if A==0 

jr main_loop


clear_screen:
;; Clear the screen 
   ld   de, #0xC000  ;; DE = Pointer to video memory location to start copying bytes
   ld   bc, #0x4000  ;; BC = 0x4000 (16K) bytes to copy (full video memory)
   ld    a, #0x00    ;; A  = 0x00, black
   
   call cpct_memset_asm ;; Fill up video memory with colour pattern
ret